

//+------------------------------------------------------------------+ 
//|                             TRO_DYNAMICFIBSSRPx.mq4            | 
//|                                                                  | 
//|                                                                  | 
//+------------------------------------------------------------------+ 
#property copyright "" 
#property link      "" 

#property indicator_chart_window 
#property indicator_buffers 4 
#property indicator_color1 Yellow 
#property indicator_color2 Yellow 
#property indicator_color3 Yellow 
#property indicator_color4 Yellow 
  

//---- input parameters 
extern bool      bDrawFibs = true; 
extern bool      bCountAllBars = false; 
extern int       iBarsToCount = 500; 
extern int       iPeriods=5; 
extern double    iLevelP1=0.382; 
extern double    iLevelP2=0.618; 

//---- buffers 
double ExtMapBuffer1[]; 
double ExtMapBuffer2[]; 
double ExtMapBuffer3[]; 
double ExtMapBuffer4[]; 


//----- internal vars 

double Dynamic_R        = 0; 
double Dynamic_S        = 0; 

double PrevDynamic_R    = 0; 
double PrevDynamic_S    = 0; 

double PrevDynamic_RP1    = 0; 
double PrevDynamic_RP2    = 0; 


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---- indicators 
   SetIndexStyle(0,DRAW_ARROW); 
   SetIndexArrow(0,119); 
   SetIndexBuffer(0,ExtMapBuffer1); 
   SetIndexEmptyValue(0,0.0); 
   SetIndexStyle(1,DRAW_ARROW); 
   SetIndexArrow(1,119); 
   SetIndexBuffer(1,ExtMapBuffer2); 
   SetIndexEmptyValue(1,0.0); 
   SetIndexStyle(2,DRAW_ARROW); 
   SetIndexArrow(2,119); 
   SetIndexBuffer(2,ExtMapBuffer3); 
   SetIndexEmptyValue(2,0.0); 
   SetIndexStyle(3,DRAW_ARROW); 
   SetIndexArrow(3,119); 
   SetIndexBuffer(3,ExtMapBuffer4); 
   SetIndexEmptyValue(3,0.0); 

  
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
    
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
   int limit; 
   int xHH,xLL,i,j; 
   if(counted_bars < 0) 
        return(-1); 
//---- 
   if(counted_bars>0) counted_bars--; 
   limit=Bars-counted_bars; 
   if (!bCountAllBars) limit = iBarsToCount; 
   for (i=0;j<limit; i++){ 
           PrevDynamic_R = Dynamic_R ; 
           PrevDynamic_S = Dynamic_S ; 
           xHH = ArrayMaximum(High,iPeriods,i);  // dynamic Resistance array index 
           xLL = ArrayMinimum(Low, iPeriods,i);  // dynamic Suport array index 
           Dynamic_R = High[xHH]; 
           Dynamic_S = Low[xLL]; 
            
          
           for(j=i; j<=i*iPeriods+xHH; j++) ExtMapBuffer1[j] = Dynamic_R; 
           for(j=i; j<=i*iPeriods+xLL; j++) ExtMapBuffer2[j] = Dynamic_S; 
           if (bDrawFibs){ 
  
                  double Range = Dynamic_R - Dynamic_S;    
                  ExtMapBuffer1[i] = Dynamic_R + (Range*iLevelP2) ; 
                  ExtMapBuffer2[i] = Dynamic_R + (Range*iLevelP1) ; 
                  ExtMapBuffer3[i] = Dynamic_S - (Range*iLevelP1) ; 
                  ExtMapBuffer4[i] = Dynamic_S - (Range*iLevelP2) ; 
            }      
   } 
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 

